interface IAppOption {
  globalData: {
    userInfo?: IUserInfo;
    url: string;
    upFileUrl: string;
    imageUrl: string;
    loginState: string;
    isLogin: 0 | 1 | 999;
    loginType: 0 | 1 | 2;
    scene: null | { [key: string]: any };
    backPath: string;
  };
  userInfoReadyCallback?: WechatMiniprogram.GetUserInfoSuccessCallback;
  waitLogin: (params?: { type?: 0 | 1 | 2 | 'any' }) => Promise<void>;
  checkLoginType: (type: 0 | 1 | 2 | 'any') => boolean;
  getMenuInfo: (arg0: WechatMiniprogram.Page.Instance<any, any>) => void;
  getUserInfo: (type: 0 | 1 | 2) => Promise<never>;
  mpBehavior: (data: { PositionId: string; OperateType: string; OperateId: string }) => void;
}

interface IAgaxParams extends WechatMiniprogram.RequestOption {
  showMsg?: boolean;
  loading?: boolean;
  isJSON?: boolean;
}

declare namespace WechatMiniprogram {
  export interface Wx {
    ajax: (arg0: IAgaxParams) => Promise<any>;
    WebIM;
  }
}

interface IUserInfo {
  UserId: string;
  IsDoctor: number;
  DoctorId: number;
  Name: string;
  Img: string;
  Telephone: string;
  HospitalId: string;
  TitleType: number;
  OtherTitle: string;
  DoctorLevel: number;
  Introduce: string;
  Department: IDepartment[];
  DepartmentId: string[];
  Specialty: ISpecialty[];
  SpecialtyId: string[];
  HospitalName: string;
  HospitalClassification: string;
  HospitalLevel: string;
  ProvinceName: string;
  CityName: string;
  CountyName: string;
  Address: string;
  HospitalClassificationName: string;
  HospitalLevelName: string;
}

interface IDepartment {
  DepartmentId: string;
  DepartmentName: string;
  DoctorId: string;
}

interface ISpecialty {
  SpecialtyId: string;
  SpecialtyName: string;
  DepartmentId: string;
  DoctorId: string;
}
